use cron qw( in_csl ACT );


###############################################################################
# main program
###############################################################################
Plugins::register('Cron', 'My task sheduler', \&event_unload, \&event_reload);
$ai_hook = Plugins::addHook('AI_pre', \&init);

my $crontab = "crontab";

sub init {

    $icur_secs = time();
    $icur_mins = int ( $icur_secs / 60 );
    $next_mins = $icur_mins + 1;
    $next_secs = $next_mins * 60;
    $sleep_secs = $next_secs - $icur_secs;
    sleep( $sleep_secs );
  #sleep (1);
    open(F, "$crontab") or 
        ACT( "$!: Can't open crontab file: $crontab" ) or
        die "Can't open crontab; file $crontab: $!\n";
    $line = 0;

    # mon = 0..11 and wday = 0..6
    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) =
        localtime(time);
    $mon++; # to get it to agree with the cron syntax
    $year %= 100;   # Y2K fix

    while (<F>) {
    #ACT($line);
       $line++;

       if (/^$/) {
        #ACT("blank line $line");
        next;
       }

       if (/^#/) {
        #ACT("comment on line $line");
        next;
       }

       ($tmin, $thour, $tmday, $tmon, $twday, $tcommand) = split(/ +/, $_, 6);

       #print("it is now $hour:$min:$sec on $mon/$mday/$year wday=$wday");
      # print("should we do $thour:$tmin on $tmon/$tmday/--, wday=$twday?");

       $do_it = 0; # assume don't do it until proven otherwise

       # do it -- this month?
       if ( ($tmon eq "*") || ($mon == $tmon) || &in_csl($mon, $tmon, '1', '12')) {
           $do_it = 1;
           #MSG("the month is valid");
       }
       else {
           $do_it = 0;
           #MSG("cron: the month is invalid");
       }

       # do it -- this day of the month?
       if ( $do_it && ( ($tmday eq "*")
            || ($mday == $tmday) || &in_csl($mday, $tmday, '1', '31')) ) {
           $do_it = 1;
           #MSG("the day of month is valid");
       }
       else {
           $do_it = 0;
           #MSG("the day of month is invalid");
       }

       # do it -- this day of the week?
       if ( $do_it && ( ($twday eq "*")
            || ($wday == $twday) || &in_csl($wday, $twday, '0', '6')) ) {
           $do_it = 1;
           #MSG("the day of week is valid");
       }
       else {
           $do_it = 0;
           #MSG("the day of week is invalid");
       }

       # do it -- this hour?
       if ( $do_it && ( ($thour eq "*") ||
            ($hour == $thour)|| &in_csl($hour, $thour, '0', '23') ) ) {
           $do_it = 1;
           #MSG("the hour is valid");
       }
       else {
           $do_it = 0;
           #MSG("the hour is invalid");
       }

       # do it -- this minute?
       if ( $do_it && ( ($tmin eq "*") ||
            ($min == $tmin) || &in_csl($min, $tmin, '0', '59') ) ) {
           $do_it = 1;
           #MSG("the min is valid");
       }
       else {
           $do_it = 0;
           #MSG("the minute is invalid");
       }

       if ($do_it) {
           chomp $tcommand;
           ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
           $year += 1900;
           $mon++;
           $DATE = sprintf "%04d%02d%02d", $year, $mon, $mday;
           $TIME = sprintf "%02d%02d%02d", $hour,$min,$sec;
           $xtcommand = $tcommand;
           $xtcommand =~ s/\$DATE/$DATE/gi;
           $xtcommand =~ s/\$TIME/$TIME/gi;

           ACT("$xtcommand");
       }
    }

    close(F);
   # ACT("***-----***");
#    sleep(60);
}


return 1;

