# cron.pm
package cron;

require Exporter;
@ISA = qw( Exporter );

@EXPORT = qw( in_csl ACT );
@EXPORT_OK = qw( in_csl ACT );

$::msgfile = ""; # assign this only in emergency

$::silent = 1 ;


use strict;

sub in_csl {
    my( $what, $csl, $start, $end );
    my ( @a, @b );
    my ( $i, $x );
    ($what, $csl, $start, $end) = @_;
    #ACT("Processing CSL");
    @a = split(/,/, $csl);
    @b = ();
    map {
#         Capture the $1/$2 format,
#           where $1 is the starting value
#           and $2 is the delta
#               until the $end value is exceeded
        if (/^(\d+)\/(\d+)$/) {
#             Delta value, $2, > 0
#             and starting value, $1, between $start and $end
            if ( $2 > 0 && $1 >= $start && $1 <= $end ) {
                for ( $i = $1; $i <= $end; $i += $2 ) {
                    push @b, $i;
                }
            }
#         Capture the */$1 format,
#           where $1 is the delta value
#           from $start to $end
        } elsif (/^\*\/(\d+)$/) {
#             Delta value, $1 > 0
            if ( $1 > 0 ) {
                for ( $i = $start; $i <= $end; $i += $1 ) {
                    push @b, $i;
                }
            }
#         Capture the $1-$2/$3
#           where $1 is the starting value
#             and $2 is the ending value
#             and $3 is the delta value
        } elsif (/^(\d+)-(\d+)\/(\d+)$/) {
#             Delta value, $3 > 0;
            if ( $3 > 0 ) {
#                 Starting value, $1, <= Ending Value, $2
                if ( $1 <= $2 ) {
                    for ( $i = $1; $i <= $2; $i += $3 ) {
                        push @b, $i;
                    }
#                 Starting value, $1, > Ending Value, $2
#                 Use the $end value to wrap from the larger
#                   value to the smaller value.
                } else {
                    for ( $i = $1; $i <= $2 + $end + (1 - $start); $i += $3 ) {
#                         Value <= $end
                        if ( $i <= $end ) {
                            push @b, $i;
#                         Value > $end
#                         Adjust to beginning values
                        } else {
                            push @b, $i - $end - (1 - $start);
                        }
                    }
                }
            }
#         Capture the $1-$2
#           where $1 is the starting value
#             and $2 is the ending value
#             therefore the delta value is 1
        } elsif (/^(\d+)-(\d+)$/) {
#             Starting value, $1, <= Ending Value, $2
            if ( $1 <= $2 ) {
                for ( $i = $1; $i <= $2; $i++ ) {
                    push @b, $i;
                }
#             Starting value, $1, > Ending Value, $2
#             Use the $end value to wrap from the larger
#               value to the smaller value.
            } else {
                for ( $i = $1; $i <= $2 + $end + (1 - $start); $i++ ) {
#                     Value <= $end
                    if ( $i <= $end ) {
                        push @b, $i;
#                     Value > $end
#                     Adjust to beginning values
                    } else {
                        push @b, $i - $end - (1 - $start);
                    }
                }
            }
#             Using perl range, $1..$2
#            push @b,$1..$2;
        } else {
#             Anything else
            push @b,$_;
        }
    } @a;
    for $x (@b) {
        #ACT("is $what equal to item $x?");
        if ($what eq $x) {
            return 1;
        }
    }
    return 0;
}


###############################################################################
# Log activity
###############################################################################

sub ACT {
    my( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst );
    my( $year4, $logfile );
    # mon = 0..11 and wday = 0..6
    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) =
    localtime(time);
    $mon++; # to get it to agree with the cron syntax
    $year4 = 1900 + $year;
    $year %= 100;   # Y2K fix

    printf "@_\n", $mon,$mday,$year,$hour,$min,$sec;

    $logfile = sprintf "logs/cron.%04d%02d%02d.log", $year4, $mon, $mday;
    # since we're appending the log, always open it only as little
    # as necessary, so if we crash the info will be there
    open(LOGFILE, ">>$logfile") or return;
    printf LOGFILE "cron*[%02d/%02d/%02d %02d:%02d:%02d]: @_\n", $mon,$mday,$year,$hour,$min,$sec;
    close(LOGFILE);
}
